﻿using UnityEngine;
using System.Collections;

public class CameraController : MonoBehaviour 
{

	public Transform Player;
	public Vector3 Margin , Smoothing;
	public BoxCollider Bounds;
	private Vector3 min,max;
	private bool IsFollowing{ get; set; }


	void Start () 
	{
		min = Bounds.bounds.min;
		max = Bounds.bounds.max;
		IsFollowing = true;
	}
	

	void Update () 
	{
		var x = transform.position.x;
		var z = transform.position.z;

		if(IsFollowing)
		{
			if(Mathf.Abs(x - Player.position.x) > Margin.x)
			{
				x = Mathf.Lerp(x, Player.position.x, Smoothing.x*Time.deltaTime);
			}
			if(Mathf.Abs(z - Player.position.z) > Margin.z)
			{
				z = Mathf.Lerp(z, Player.position.z, Smoothing.z*Time.deltaTime);
			}
		}

		var cameraHalfWidth = GetComponent<Camera>().orthographicSize * ((float) Screen.width/Screen.height);
		x = Mathf.Clamp(x, min.x + cameraHalfWidth, max.x - cameraHalfWidth);
		z = Mathf.Clamp(z, min.z + GetComponent<Camera>().orthographicSize, max.z - GetComponent<Camera>().orthographicSize);

		transform.position = new Vector3(x, transform.position.y, z);
	}
}























