﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class EnemySpawner : MonoBehaviour {

    public GameObject enemyPrefab;
    public float spawnRate;
    public int maxEnemy;

    public static List<GameObject> enemyList = new List<GameObject>();
    float lastSpawnTime;
    Vector3 newPosition;

	// Use this for initialization
	void Start () {
        enemyPrefab.name = "RandomEnemy";
        lastSpawnTime = Time.time;
	}
	
	// Update is called once per frame
	void Update () {
        if (Time.time - lastSpawnTime >= spawnRate)
        {
            if (enemyList.Count < maxEnemy)
            {
                searchNewPosition();
                GameObject newEnemy = Instantiate(enemyPrefab, newPosition, Quaternion.identity) as GameObject;
                enemyList.Add(newEnemy);
            }
            lastSpawnTime = Time.time;
        }
    }

    void searchNewPosition()
    {
        newPosition = new Vector3(Random.Range(-14.5f, 14.0f), 0.5f, Random.Range(-5.5f, 11.5f));
        if (Mathf.Abs(newPosition.x - transform.position.x) < 4 ||
            Mathf.Abs(newPosition.z - transform.position.z) < 4)
            searchNewPosition();
    }
}
