﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class Health : MonoBehaviour {

    public int maxHealth;
    public float damageDelay;
    public GameObject deathEffect;

    int health;
    Slider healthBar;
    float lastDamageTime;
    PoolSound poolSound;
    GameManager master;

	// Use this for initialization
	void Start () {
        health = maxHealth;
        master = GameObject.Find("Main Camera").GetComponent<GameManager>();
        poolSound = GameObject.Find("Main Camera").GetComponent<PoolSound>();
        if (gameObject.tag == "Player")
        {
            healthBar = GameObject.Find("healthBar").GetComponent<Slider>();
            healthBar.value = 1.0f;
            lastDamageTime = Time.time;
        }
	}
	
	// Update is called once per frame
	void Update () {
	    
	}

    public void ApplyDamage(int x)
    {
        
        if(gameObject.tag == "Player" && (Time.time - lastDamageTime > damageDelay))
        {
            health -= x;
            healthBar.value = (float) health / maxHealth;
            lastDamageTime = Time.time;
        } else if(gameObject.tag == "Enemy")
        {
            health -= x;
        }

        if( health <= 0 )
        {
            poolSound.playsoundatCameraNow(2, 1.0f);
            if (gameObject.tag == "Player")
            {
                master.GameOver();
            }
            else if (gameObject.tag == "Enemy") {
                Instantiate(deathEffect, gameObject.transform.position,new Quaternion(90,0,0,0));
                GameManager.score += 1;
                EnemySpawner.enemyList.Remove(gameObject);
                Destroy(gameObject);
            }
        }
    }
}
